package xyz.zhouxy.plusone.commons.net;

import java.net.NetworkInterface;
import java.util.Arrays;
import java.util.Objects;

public class NetworkInterfaceInfo {
    private final NetworkInterface networkInterface;
    private final byte[] mac;

    NetworkInterfaceInfo(NetworkInterface networkInterface, byte[] mac) {
        this.networkInterface = Objects.requireNonNull(networkInterface);
        this.mac = Objects.requireNonNull(mac);
    }

    public NetworkInterface getNetworkInterface() {
        return networkInterface;
    }

    public byte[] getMac() {
        return Arrays.copyOf(this.mac, this.mac.length);
    }

    public String getMacStr() {
        final StringBuilder result = new StringBuilder();
        String s;
        for (int i = 0; i < this.mac.length; i++) {
            if (i != 0) {
                result.append("-");
            }
            s = Integer.toHexString(this.mac[i] & 0xFF);
            if (s.length() == 1) {
                result.append("0");
            }
            result.append(s);
        }
        return result.toString();
    }
}
